// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
var app=angular.module('starter', ['ionic','pdf','ngCordova', 'ngStorage','ui.select', 'ngSanitize','starter.controllers', 'starter.services',
                           'starter.usermanagement.controllers',
                           'starter.usermanagement.services',
                           'starter.addressmanagement.controllers',
                           'starter.addressmanagement.services',
                           'starter.contractmanagement.controllers',
                           'starter.contractmanagement.services',
                           'ionic-datepicker',
                           'admobModule'
                           ])

.run(function($rootScope,$ionicPlatform,$localStorage,Ie18,$timeout,admobSvc) {
	

  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);
      window.plugin.notification.local.onadd = function (id, state, json) {
          var notification = {
              id: id,
              state: state,
              json: json
          };
          $timeout(function() {
              $rootScope.$broadcast("$cordovaLocalNotification:added", notification);
          });
      };
      admobSvc.createBannerView();
    }
    
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }
    if(window.device){
    	console.log("zz", window.device.uuid );
    	if(window.device.platform === "iOS") {
    		window.plugin.notification.local.promptForPermission();
    	}
    }
    
	$rootScope.ie18=Ie18;
	$rootScope.$storage = $localStorage.$default({
	    addresses: [],
	    contracts:[],
	    users:[],
	    nextid:0
	});
	$rootScope.isDevice=window.cordova?true:false;
	$rootScope.actualUser={};
	$rootScope.language_list=[
	                          {url:'img/flag-germany.png',name:'de',fullname:'Deutsch'},
	                          {url:'img/flag-england.png',name:'en',fullname:'Englisch'},
	                          {url:'img/flag-france.png',name:'fr',fullname:'Français'}
	                          ];
			
	$rootScope.languageSelected = function (item, model){
	    $rootScope.settings.language=model;
	  };
	$rootScope.nextid=function(){
		var id=$localStorage.nextid;
		$localStorage.nextid=id+1;
		return id;
	}
	$rootScope.settings={
			language:"de"
				};
	$rootScope.useLanguage=function(language){
		$rootScope.settings.language=language;
	};
	$rootScope.T=function(key){
		if(key==''){
			return '';
		}
		var langKey=this.settings.language+"."+key;
		var value=this.ie18.get(this.settings.language,key);
		if(value==null){
			return langKey;
		}
		return value;
	};
  
    $rootScope.lang={};
    $rootScope.lang.selected = $rootScope.language_list[0];
  });
})

.config(function($stateProvider, $urlRouterProvider) {

  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js
  $stateProvider

  // setup an abstract state for the tabs directive
    .state('tab', {
    url: '/tab',
    abstract: true,
    templateUrl: 'templates/tabs.html'
  })

  // Each tab has its own nav history stack:

  .state('tab.dash', {
    url: '/dash',
    views: {
      'tab-dash': {
        templateUrl: 'templates/tab-dash.html',
        controller: 'DashCtrl'
      }
    }
  })

  .state('tab.chats', {
      url: '/chats',
      views: {
        'tab-chats': {
          templateUrl: 'templates/tab-chats.html',
          controller: 'ChatsCtrl'
        }
      }
    })
    .state('tab.chat-detail', {
      url: '/chats/:chatId',
      views: {
        'tab-chats': {
          templateUrl: 'templates/chat-detail.html',
          controller: 'ChatDetailCtrl'
        }
      }
    })

  .state('tab.account', {
    url: '/account',
    views: {
      'tab-account': {
        templateUrl: 'templates/tab-account.html',
        controller: 'AccountCtrl'
      }
    }
  })
  .state('tab.home', {
    url: '/home',
    cache:false,
    views: {
      'tab-home': {
        templateUrl: 'templates/home.html',
        controller: 'HomeCtrl'
      }
    }
  })
   .state('tab.end-contract-detail', {
      url: '/endcontracts/:id',
      views: {
        'tab-home': {
          templateUrl: 'templates/contractmanagement/detail.html',
          controller: 'ContractDetailCtrl'
        }
      }
    })
  .state('tab.userprofil', {
    url: '/userprofil',
    cache:false,
    views: {
      'tab-userprofil': {
        templateUrl: 'templates/usermanagement/userprofil.html',
        controller: 'UserProfilCtrl'
      }
    }
  })
  .state('tab.addressoverview', {
    url: '/addressoverview',
    cache:false,
    views: {
      'tab-addressoverview': {
        templateUrl: 'templates/addressmanagement/addressOverview.html',
        controller: 'AddCtrl'
      }
    }
  })
  .state('tab.addaddress', {
    url: '/addaddress',
    cache:false,
    views: {
      'tab-addressoverview': {
        templateUrl: 'templates/addressmanagement/addAddress.html',
        controller: 'AddCtrl'
      }
    }
  })
   .state('tab.address-detail', {
      url: '/addresses/:addrId/:userId',
      views: {
        'tab-addressoverview': {
          templateUrl: 'templates/addressmanagement/addressDetail.html',
          controller: 'AddrDetailCtrl'
        }
      }
    })
    .state('tab.addcontract-fromcompany', {
    url: '/addcontract-fromcompany/:addrId',
    cache:false,
    views: {
      'tab-addressoverview': {
        templateUrl: 'templates/contractmanagement/add.html',
        controller: 'ContractCtrl'
      }
    }
  })
  .state('tab.company-contract-detail', {
      url: '/companycontracts/:id',
      views: {
        'tab-addressoverview': {
          templateUrl: 'templates/contractmanagement/detail.html',
          controller: 'ContractDetailCtrl'
        }
      }
    })
    .state('tab.contractoverview', {
    url: '/contractoverview',
    cache:false,
    views: {
      'tab-contractoverview': {
        templateUrl: 'templates/contractmanagement/overview.html',
        controller: 'ContractCtrl'
      }
    }
  })
  .state('tab.addcontract', {
    url: '/addcontract',
    cache:false,
    views: {
      'tab-contractoverview': {
        templateUrl: 'templates/contractmanagement/add.html',
        controller: 'ContractCtrl'
      }
    }
  })
   .state('tab.contract-detail', {
      url: '/contracts/:id',
      views: {
        'tab-contractoverview': {
          templateUrl: 'templates/contractmanagement/detail.html',
          controller: 'ContractDetailCtrl'
        }
      }
    })
  .state('tab.contractpdf', {
      url: '/contractpdf',
      views: {
        'tab-pdf': {
          templateUrl: 'templates/contractmanagement/pdf.html',
          controller: 'ContractPdfCtrl'
        }
      }
    })
  
  .state('login', {
    url: '/login',
    templateUrl: 'templates/usermanagement/login.html',
    controller: 'AuthCtrl'
  })
  .state('signin', {
    url: '/signin',
    templateUrl: 'templates/usermanagement/signin.html',
    controller: 'SignCtrl'
  })
   
  ;

  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/login');
//  $timeout(function() {
//	}, 5000);
 
  
});
app.filter('propsFilter', function() {
	  return function(items, props) {
	    var out = [];

	    if (angular.isArray(items)) {
	      var keys = Object.keys(props);

	      items.forEach(function(item) {
	        var itemMatches = false;

	        for (var i = 0; i < keys.length; i++) {
	          var prop = keys[i];
	          var text = props[prop].toLowerCase();
	          if (item[prop].toString().toLowerCase().indexOf(text) !== -1) {
	            itemMatches = true;
	            break;
	          }
	        }

	        if (itemMatches) {
	          out.push(item);
	        }
	      });
	    } else {
	      // Let the output be the input untouched
	      out = items;
	    }

	    return out;
	  };
	});
app.directive('focusMe', ['$timeout',function() {
	  return {
		restrict:'EA',
	    link: function($scope, $element) {
	    	 
	      $timeout(function() {
	    	  console.log($element);
		    	$element[0].focus();
	      },10);
	    }
	  };
	}]);
app.config(function ($injector,ionicDatePickerProvider) {
    var datePickerObj = {
      inputDate: new Date(),
      titleLabel: 'Select a Date',
      setLabel: 'Set',
      todayLabel: 'Today',
      closeLabel: 'Close',
      mondayFirst: false,
      weeksList: ["S", "M", "T", "W", "T", "F", "S"],
      monthsList: ["Jan", "Feb", "March", "April", "May", "June", "July", "Aug", "Sept", "Oct", "Nov", "Dec"],
      templateType: 'popup',
      showTodayButton: false,
      dateFormat: 'dd-MM-yyyy',
      closeOnSelect: false,
      disableWeekdays: []
    };
    ionicDatePickerProvider.configDatePicker(datePickerObj);
  });
app.config(['admobSvcProvider', function (admobSvcProvider) {
      // Optionally you can configure the options here:
      admobSvcProvider.setOptions({
        publisherId:          "ca-app-pub-3144364759225856/9148010721",  // Required
        interstitialAdId:     "ca-app-pub-3144364759225856/9148010721",  // Optional
        isTesting:false
      });
    }]);