angular.module('starter.contractmanagement.controllers', [])
		.controller(
				'ContractCtrl',
				function($rootScope,$scope, ContractService, $location, UserService,AddressService,
						$stateParams,ionicDatePicker,$timeout) {
					$scope.actualUser = UserService.actualUser;
					var addr = AddressService.get($stateParams.addrId);
					if (addr == null) {
						addr = {
							city : '',
							citycode : '',
							street : '',
							streetnumber : '',
							country : '',
							token : '',
							companyname : '',
							companytyp : '',
							email : '',
							id:''
						}
					}
					$scope.contractdto = {
						displayname:'',
						partner : addr.companyname,
						start : new Date(),
						end : new Date(),
						typ : $rootScope.T(addr.companytyp),
						clientnumber:'',
						referenz : '',
						partnerEmail : addr.email,
						partnerTel : '',
						remindDateForResiliation : '',
						partnerStreet : addr.street,
						partnerCity : addr.citycode + ' '+addr.city,
						partnerCountry : addr.country,
						uid : UserService.actualUser.id,
						addrid:addr.id,
						reminderCode:''
					};
					$scope.addContract = function() {
						ContractService.addContract($scope.contractdto);
						if ($location.path().indexOf("addcontract-fromcompany") != -1) {
							if(window.addrDetailCtrlScope){
								window.addrDetailCtrlScope.updateCompanyContract();
							}
							$location.path("/tab/addresses/"+addr.id+"/"+$scope.contractdto.uid);
							
						}else{
						$location.path("/tab/contractoverview");
						}
						
					};
					$scope.contracts = ContractService.loadContracts(
							$scope.actualUser.id, $scope.actualUser.token);
					
					$scope.contractstart = {
						      callback: function (val) { 
						    	  $scope.contractstart.inputDate=new Date(val);
						    	  $scope.contractdto.start=new Date(val);
						      },
						      disabledDates: [ ],
						      setLabel: $rootScope.T('set'),
						      todayLabel: $rootScope.T('today'),
						      closeLabel: $rootScope.T('close'),
						      weeksList: [$rootScope.T("abbr_sunday"), $rootScope.T("abbr_monday"), $rootScope.T("abbr_tuesday"), $rootScope.T("abbr_wenesday"), $rootScope.T("abbr_thursday"), $rootScope.T("abbr_friday"), $rootScope.T("abbr_saturday")],
						      monthsList: [$rootScope.T("Jan"), $rootScope.T("Feb"), $rootScope.T("March"), $rootScope.T("April"), $rootScope.T("May"), $rootScope.T("June"), $rootScope.T("July"), $rootScope.T("Aug"), $rootScope.T("Sept"), $rootScope.T("Oct"), $rootScope.T("Nov"), $rootScope.T("Dec")],
						      inputDate: new Date($scope.contractdto.start),      //Optional
						      mondayFirst: true,          //Optional
						      closeOnSelect: false,       //Optional
						      templateType: 'popup'       //Optional
						    };
				 
					$scope.openStartDatePicker = function(){

						$timeout(function(){$scope.contractstart.inputDate=$scope.contractdto.start;
						   ionicDatePicker.openDatePicker($scope.contractstart);},"100");
				   };
				   $scope.contractend= {
						      callback: function (val) { 
						    	  $scope.contractend.inputDate=new Date(val);
						    	  $scope.contractdto.end=new Date(val);
						      },
						      disabledDates: [ ],
						      setLabel: $rootScope.T('set'),
						      todayLabel: $rootScope.T('today'),
						      closeLabel: $rootScope.T('close'),
						      weeksList: [$rootScope.T("abbr_sunday"), $rootScope.T("abbr_monday"), $rootScope.T("abbr_tuesday"), $rootScope.T("abbr_wenesday"), $rootScope.T("abbr_thursday"), $rootScope.T("abbr_friday"), $rootScope.T("abbr_saturday")],
						      monthsList: [$rootScope.T("Jan"), $rootScope.T("Feb"), $rootScope.T("March"), $rootScope.T("April"), $rootScope.T("May"), $rootScope.T("June"), $rootScope.T("July"), $rootScope.T("Aug"), $rootScope.T("Sept"), $rootScope.T("Oct"), $rootScope.T("Nov"), $rootScope.T("Dec")],
						      inputDate: new Date($scope.contractdto.end),      //Optional
						      mondayFirst: true,          //Optional
						      closeOnSelect: false,       //Optional
						      templateType: 'popup'       //Optional
						    };
				   $scope.openEndDatePicker = function(){
					   
					   $timeout(function(){$scope.contractend.inputDate=$scope.contractdto.end;
					   ionicDatePicker.openDatePicker($scope.contractend);},"100");
			  
				   };
				
				}).controller(
				'ContractDetailCtrl',
				function($ionicLoading,$rootScope, $scope, $stateParams, $location,
						ContractService, EmailService, FileReader, UserService,
						PdfMaker,$timeout,ionicDatePicker) {
					_activate();

					function _activate() {
						//
						// ReportSvc Event Listeners: Progress/Done
						// used to listen for async progress updates so loading
						// text can change in
						// UI to be repsonsive because the report process can be
						// 'lengthy' on
						// older devices (chk reportSvc for emitting events)
						//
						$scope.$on('ReportSvc::Progress', function(event, msg) {
							_showLoading(msg);
						});
						$scope.$on('ReportSvc::Done', function(event, err) {
							_hideLoading();
						});
					}

					//
					// Loading UI Functions: utility functions to show/hide
					// loading UI
					//
					function _showLoading(msg) {
						$ionicLoading.show({
							template : msg
						});
					}
					function _hideLoading() {
						$ionicLoading.hide();
					}

					$scope.contract = ContractService.get($stateParams.id);
					$scope.contract.start = new Date($scope.contract.start);
					$scope.contract.end = new Date($scope.contract.end);
					$scope.isdevice = window.cordova;
					$scope.edit = function() {
						this.editing = !this.editing;
					};
					$scope.editing = false;
					$scope.resiliate = function() {
						var template = this.settings.language
								+ "_standard.html";
						FileReader.readFile(
								"templates/resiliation/" + template,
								$scope.contract, UserService.actualUser, $scope
										.T("resiliationOfContract"),
								EmailService.sendMessage);
					};
					$scope.createpdf = function() {
						PdfMaker.createResiliationPDF(UserService.actualUser,
								$scope.contract, this.settings.language);
						if(!window.cordova){
							$location.path("/tab/contractpdf");
						}
					};
					$scope.remove = function() {
						ContractService.remove($stateParams.id);
						if(window.addrDetailCtrlScope){
							window.addrDetailCtrlScope.updateCompanyContract();
						}
						if ($location.path().indexOf("endcontracts") != -1) {
							$location.path("/tab/home");
						} else {
							$location.path("/tab/contractoverview");
						}
					};
					$scope.saveContract = function() {
						ContractService.update($scope.contract.id,
								$scope.contract);
						this.editing = false;
						if(window.addrDetailCtrlScope){
							window.addrDetailCtrlScope.updateCompanyContract();
						}
					};
					$scope.contractstart = {
						      callback: function (val) { 
						    	  $scope.contractstart.inputDate=new Date(val);
						    	  $scope.contract.start=new Date(val);
						      },
						      disabledDates: [ ],
						      setLabel: $rootScope.T('set'),
						      todayLabel: $rootScope.T('today'),
						      closeLabel: $rootScope.T('close'),
						      weeksList: [$rootScope.T("abbr_sunday"), $rootScope.T("abbr_monday"), $rootScope.T("abbr_tuesday"), $rootScope.T("abbr_wenesday"), $rootScope.T("abbr_thursday"), $rootScope.T("abbr_friday"), $rootScope.T("abbr_saturday")],
						      monthsList: [$rootScope.T("Jan"), $rootScope.T("Feb"), $rootScope.T("March"), $rootScope.T("April"), $rootScope.T("May"), $rootScope.T("June"), $rootScope.T("July"), $rootScope.T("Aug"), $rootScope.T("Sept"), $rootScope.T("Oct"), $rootScope.T("Nov"), $rootScope.T("Dec")],
						      inputDate: $scope.contract.start,      //Optional
						      mondayFirst: true,          //Optional
						      closeOnSelect: false,       //Optional
						      templateType: 'popup'       //Optional
						    };
				 
					$scope.openStartDatePicker = function(){
						$timeout(function(){$scope.contractstart.inputDate=$scope.contract.start;
						   ionicDatePicker.openDatePicker($scope.contractstart);},"100");
				   };
				   $scope.contractend= {
						      callback: function (val) { 
						    	  $scope.contractend.inputDate=new Date(val);
						    	  $scope.contract.end=new Date(val);
						      },
						      disabledDates: [ ],
						      setLabel: $rootScope.T('set'),
						      todayLabel: $rootScope.T('today'),
						      closeLabel: $rootScope.T('close'),
						      weeksList: [$rootScope.T("abbr_sunday"), $rootScope.T("abbr_monday"), $rootScope.T("abbr_tuesday"), $rootScope.T("abbr_wenesday"), $rootScope.T("abbr_thursday"), $rootScope.T("abbr_friday"), $rootScope.T("abbr_saturday")],
						      monthsList: [$rootScope.T("Jan"), $rootScope.T("Feb"), $rootScope.T("March"), $rootScope.T("April"), $rootScope.T("May"), $rootScope.T("June"), $rootScope.T("July"), $rootScope.T("Aug"), $rootScope.T("Sept"), $rootScope.T("Oct"), $rootScope.T("Nov"), $rootScope.T("Dec")],
						      inputDate: $scope.contract.end,      //Optional
						      mondayFirst: true,          //Optional
						      closeOnSelect: false,       //Optional
						      templateType: 'popup'       //Optional
						    };
				   $scope.openEndDatePicker = function(){
					   $timeout(function(){$scope.contractend.inputDate=$scope.contract.end;
					   ionicDatePicker.openDatePicker($scope.contractend);},"100");
				   };
					
				}).controller(
						'ContractPdfCtrl',function($scope, $stateParams, $location,$ionicNavBarDelegate,ContractService){
						});
