angular.module('starter.contractmanagement.services', []).factory('ContractService',
		function($localStorage,$filter,$rootScope,$cordovaLocalNotification,ReminderService) {
			return {
				contracts : $localStorage.contracts,
				loadContracts : function(uid,token) {
					//TODO
					_contracts=[];
					for(i=0;i<$localStorage.contracts.length;i++){
						if($localStorage.contracts[i].uid!=null && $localStorage.contracts[i].uid==uid){
							_contracts.push($localStorage.contracts[i]);
						}
					}
					return  _contracts;
				},
				loadForCompany: function(compid,uid){
					_contracts=[];
					for(i=0;i<$localStorage.contracts.length;i++){
						var addid=$localStorage.contracts[i].addrid;
						var cuid=$localStorage.contracts[i].uid;
						if(addid!=null && addid==compid && cuid!=null && cuid==uid){
							_contracts.push($localStorage.contracts[i]);
						}
					}
					return  _contracts;
				},
				getContractsToRemind: function(uid,token){
					_contracts=this.loadContracts(uid,token);
					result=[];
					var today=new Date(Date.now());
					for( i=0;i<_contracts.length;i++){
						var con=_contracts[i];
						if(con.alarmTime==null){
							continue;
						}
						var diff=(new Date(con.alarmTime)-today);
						if(diff<=0){
							result.push(con);
						}
					}
					return  result;
					
				},
				getLessThanThreeMonthsContract: function(uid,token){
					_contracts=this.loadContracts(uid,token);
					result=[];
					var now=new Date();
					var intreeM=new Date(now.getFullYear(),now.getMonth()+3);
					var inthreemonth=parseInt(new Date().getFullYear())+parseInt(new Date().getMonth())+3;
					for( i=0;i<_contracts.length;i++){
						var con=_contracts[i];
						var end=new Date();
						try{
							end=new Date(con.end);
						}catch(e){
							end=new Date();
						}
						endint=parseInt(end.getFullYear())+parseInt(end.getMonth());
						var diff=(intreeM-end)/(1000*60*60*24*30);
						if(diff>=0){
							result.push(con);
						}
					}
					return  result;
					
				},
				addAlarm:function(contractdto){
					var rcode=contractdto.reminderCode==null?"R_14_W":contractdto.reminderCode;
					var alarmTime = ReminderService.generateReminderDate(contractdto.end,rcode);
				    //alarmTime.setHours(10);
				    //alarmTime.setMinutes(0);
				    
//				    var alarmTime = new Date();
//				    alarmTime.setMinutes(alarmTime.getMinutes() + 1);
				    contractdto.alarmTime=alarmTime;
				    var title=contractdto.displayname+" " +$rootScope.T('to')+" "+$filter('date')(contractdto.end, "dd.MM.yy");
				   if(window.cordova){
				    $cordovaLocalNotification.add({
				        id: contractdto.id,
				        date: new Date(alarmTime),
				        message: $rootScope.T("contract.remind.text"),
				        title: title,
				        autoCancel: true,
				        sound: null
				    }).then(function () {
				        console.log("The notification has been set");
				    });
				   }
				},
				addContract : function(contractdto) {
					contractdto.id= $rootScope.nextid();
					this.addAlarm(contractdto);
					
				    $localStorage.contracts.push(contractdto);
					//TODO call webservice
				},
				get :function(id){
					for(i=0;i<$localStorage.contracts.length;i++){
						if($localStorage.contracts[i].id==id){
							return $localStorage.contracts[i];
						}
					}
					return null;
				},
				update:function(id,contract){
					this.remove(id);
					this.addAlarm(contract);
					$localStorage.contracts.push(contract);
				},

				remove:function(id){
					var contracttemp=this.get(id);
					$localStorage.contracts.splice($localStorage.contracts.indexOf(contracttemp), 1);
				}
			};
		});
